#import "AppticsFlutterPlugin.h"

@implementation AppticsFlutterPlugin

UIWindow *window;
NSUInteger childviewcontrollers;

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {

    [Apptics initializeWithVerbose:true];
    
    FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"apptics_flutter"
            binaryMessenger:[registrar messenger]];
    AppticsFlutterPlugin* instance = [[AppticsFlutterPlugin alloc] init];
    [Apptics setUserConsentPresentCompletionHandler:^(bool status, NSError *error) {
        
    }];
    
    [Apptics setUserConsentDismissCompletionHandler:^(int status) {
        [instance openSettings];
    }];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if ([@"enableAutomaticEventTracking" isEqualToString:call.method]) {
        [self enableAutomaticEventTracking:call result:result];
    } else if ([@"enableAutomaticScreenTracking" isEqualToString:call.method]) {
        [self enableAutomaticScreenTracking:call result:result];
    } else if ([@"enableAutomaticCrashTracking" isEqualToString:call.method]) {
        [self enableAutomaticCrashTracking:call result:result];
    } else if ([@"setCrashCustomProperty" isEqualToString:call.method]) {
        [self setCustomProperties:call result:result];
    } else if ([@"enableReviewAndSendCrashReport" isEqualToString:call.method]) {
        [self enableReviewAndSendCrashReport:call result:result];
    } else if ([@"getPrivacyStatus" isEqualToString:call.method]) {
        [self getPrivacyStatus:call result:result];
    } else if ([@"presentPrivacyReviewPopup" isEqualToString:call.method]) {
        [self presentPrivacyReviewPopup:call result:result];
    } else if ([@"resetConsentPreference" isEqualToString:call.method]) {
        [self resetConsentPreference:call result:result];
    } else if ([@"reset" isEqualToString:call.method]) {
        [self reset:call result:result];
    } else if ([@"flush" isEqualToString:call.method]) {
        [self flush:call result:result];
    } else if ([@"trackSignUp" isEqualToString:call.method]) {
        [self trackSignUp:call result:result];
    } else if ([@"trackLogIn" isEqualToString:call.method]) {
        [self trackLogIn:call result:result];
    } else if ([@"trackLogOut" isEqualToString:call.method]) {
        [self trackLogOut:call result:result];
    } else if ([@"trackSignUpWithGroupID" isEqualToString:call.method]) {
        [self trackSignUpWithGroupID:call result:result];
    } else if ([@"trackLogInWithGroupID" isEqualToString:call.method]) {
        [self trackLogInWithGroupID:call result:result];
    } else if ([@"trackLogOutWithGroupID" isEqualToString:call.method]) {
        [self trackLogOutWithGroupID:call result:result];
    } else if ([@"setUser" isEqualToString:call.method]) {
        [self setCurrentUser:call result:result];
    } else if ([@"setCurrentUserWithGroupId" isEqualToString:call.method]) {
        [self setCurrentUserWithGroupId:call result:result];
    } else if ([@"openPrivacySettings" isEqualToString:call.method]) {
        [self openPrivacySettings:call result:result];
    } else if ([@"getTrackingState" isEqualToString:call.method]) {
        [self getTrackingState:call result:result];
    } else if ([@"setTrackingState" isEqualToString:call.method]) {
        [self setTrackingState:call result:result];
    } else if ([@"trackingStatus" isEqualToString:call.method]) {
        [self trackingStatus:call result:result];
    } else if ([@"setTrackingStatus" isEqualToString:call.method]) {
        [self setTrackingStatus:call result:result];
    } else if ([@"crashReportStatus" isEqualToString:call.method]) {
        [self crashReportStatus:call result:result];
    } else if ([@"setCrashReportStatus" isEqualToString:call.method]) {
        [self setCrashReportStatus:call result:result];
    } else if ([@"personalInfoTrackingStatus" isEqualToString:call.method]) {
        [self personalInfoTrackingStatus:call result:result];
    } else if ([@"setPersonalInfoTrackingStatus" isEqualToString:call.method]) {
        [self setPersonalInfoTrackingStatus:call result:result];
    } else if ([@"isUserLoggedIn" isEqualToString:call.method]) {
        [self isUserLoggedIn:call result:result];
    } else if ([@"setSendAnalyticsDataUsingMobileData" isEqualToString:call.method]) {
        [self setSendAnalyticsDataUsingMobileData:call result:result];
    } else if ([@"sendAnalyticsDataUsingMobileData" isEqualToString:call.method]) {
        [self sendAnalyticsDataUsingMobileData:call result:result];
    } else if ([@"getLocalizableStringForKey" isEqualToString:call.method]) {
        [self getLocalizableStringForKey:call result:result];
    } else if ([@"setDefaultLanguage" isEqualToString:call.method]) {
        [self setDefaultLanguage:call result:result];
    } else if ([@"setCurrentLocation" isEqualToString:call.method]) {
        [self setCurrentLocation:call result:result];
    } else if ([@"setPrivacyConsentType" isEqualToString:call.method]) {
        [self setPrivacyConsentType:call result:result];
    } else if ([@"setTypeOfAnonymity" isEqualToString:call.method]) {
        [self setTypeOfAnonymity:call result:result];
    } else if ([@"enableAutoCheckForAppUpdate" isEqualToString:call.method]) {
        [self enableAutoCheckForAppUpdate:call result:result];
    } else if ([@"crash" isEqualToString:call.method]) {
        [self crash:call result:result];
    } else if ([@"isReachable" isEqualToString:call.method]) {
        [self isReachable:call result:result];
    } else if ([@"addEvent" isEqualToString:call.method]) {
        [self addEvent:call result:result];
    } else if ([@"screenAttached" isEqualToString:call.method]) {
        [self trackViewEnter:call result:result];
    } else if ([@"screenDetached" isEqualToString:call.method]) {
        [self trackViewExit:call result:result];
    } else  {
        result(FlutterMethodNotImplemented);
    }
}
//enableAutomaticEventTracking
- (void)enableAutomaticEventTracking:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics enableAutomaticEventTracking:status.boolValue];
    result(nil);
}
//enableAutomaticScreenTracking
- (void)enableAutomaticScreenTracking:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics enableAutomaticScreenTracking:status.boolValue];
    result(nil);
}
//enableAutomaticCrashTracking
- (void)enableAutomaticCrashTracking:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics enableAutomaticCrashTracking:status.boolValue];
    result(nil);
}
//setCustomProperties
- (void)setCustomProperties:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSDictionary *custom_properties = call.arguments[@"properties"];
    [Apptics setCrashCustomProperty:custom_properties];
    result(nil);
}
//enableReviewAndSendCrashReport
- (void)enableReviewAndSendCrashReport:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics enableReviewAndSendCrashReport:status.boolValue];
    result(nil);
}
//getPrivacyStatus
- (void)getPrivacyStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = @([Apptics getPrivacyStatus]);
    result(status);
}
//showPrivacyReviewPopup
- (void)presentPrivacyReviewPopup:(FlutterMethodCall*)call result:(FlutterResult)result{
    [Apptics showPrivacyConsent];
    result(nil);
}
//resetConsentPreference
- (void)resetConsentPreference:(FlutterMethodCall*)call result:(FlutterResult)result{
    [Apptics resetConsentPreference];
    result(nil);
}
//reset
- (void)reset:(FlutterMethodCall*)call result:(FlutterResult)result{
    [Apptics reset];
    result(nil);
}
//flush
- (void)flush:(FlutterMethodCall*)call result:(FlutterResult)result{
    [Apptics flush];
    result(nil);
}
//trackSignUp:(NSString* _Nullable)userID)
- (void)trackSignUp:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    [Apptics trackSignUp:userID];
    result(nil);
}
//trackLogIn:(NSString* _Nullable)userID)
- (void)trackLogIn:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    [Apptics trackLogIn:userID];
    result(nil);
}
//trackLogOut:(NSString* _Nullable)userID
- (void)trackLogOut:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    [Apptics trackLogOut:userID];
    result(nil);
}
//trackSignUpWithGroupID:(NSString* _Nullable)userID groupId : (NSString*_Nullable)groupID
- (void)trackSignUpWithGroupID:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    NSString *groupID = call.arguments[@"group_id"];
    [Apptics trackSignUp:userID groupId:groupID];
    result(nil);
}
//trackLogInWithGroupID:(NSString* _Nullable)userID groupId : (NSString*_Nullable)groupID
- (void)trackLogInWithGroupID:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    NSString *groupID = call.arguments[@"group_id"];
    [Apptics trackLogIn:userID groupId:groupID];
    result(nil);
}
//trackLogOutWithGroupID:(NSString* _Nullable)userID groupId : (NSString*_Nullable)groupID){
- (void)trackLogOutWithGroupID:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    NSString *groupID = call.arguments[@"group_id"];
    [Apptics trackLogOut:userID groupId:groupID];
    result(nil);
}
//setCurrentUser:(NSString * _Nullable)userID
- (void)setCurrentUser:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    [Apptics setCurrentUser:userID];
    result(nil);
}
//setCurrentUserWithGroupId:(NSString * _Nullable)userID groupId : (NSString*_Nullable)groupID
- (void)setCurrentUserWithGroupId:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *userID = call.arguments[@"user_id"];
    NSString *groupID = call.arguments[@"group_id"];
    [Apptics setCurrentUser:userID groupId:groupID];
    result(nil);
}
//openSettings
-(void) openSettings{
    window = [[UIWindow alloc] initWithFrame:[UIScreen mainScreen].bounds];
    UIViewController *rootViewController = [UIViewController new];
    UINavigationController *navigationController = [[UINavigationController alloc] initWithRootViewController:rootViewController];
    navigationController.delegate = self;
    
    window.rootViewController = navigationController;
    [window makeKeyAndVisible];
//        window.backgroundColor = [UIColor blueColor];
    double delayInSeconds = 0.2;
    dispatch_time_t popTime = dispatch_time(DISPATCH_TIME_NOW, (int64_t)(delayInSeconds * NSEC_PER_SEC));
    dispatch_after(popTime, dispatch_get_main_queue(), ^(void){
        [Apptics openAnalyticSettingsController: navigationController];
    });
}

- (void)openPrivacySettings:(FlutterMethodCall*)call result:(FlutterResult)result{
    [self openSettings];
    result(nil);
}

- (NSNumber*) getTrackingState{
    if ([Apptics trackingStatus] == true && [Apptics crashReportStatus] == true && [Apptics personalInfoTrackingStatus] == true){
        return @(1);
    }else if ([Apptics trackingStatus] == true && [Apptics crashReportStatus] == true && [Apptics personalInfoTrackingStatus] == false){
        return @(4);
    }else if ([Apptics trackingStatus] == true && [Apptics personalInfoTrackingStatus] == true){
        return @(2);
    }else if ([Apptics trackingStatus] == true && [Apptics personalInfoTrackingStatus] == false){
        return @(5);
    }else if ([Apptics crashReportStatus] == true && [Apptics personalInfoTrackingStatus] == true){
        return @(3);
    }else if ([Apptics crashReportStatus] == true && [Apptics personalInfoTrackingStatus] == false){
        return @(6);
    }else{
        return @0;
    }
}
//getTrackingState
- (void)getTrackingState:(FlutterMethodCall*)call result:(FlutterResult)result{
    result([self getTrackingState]);
}

- (void)setTrackingState:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    if ([status isEqual: @(1)]){
        [Apptics setTrackingStatus:true];
        [Apptics setCrashReportStatus:true];
        [Apptics setPersonalInfoTrackingStatus:true];
    }else if ([status isEqual: @(2)]){
        [Apptics setTrackingStatus:true];
        [Apptics setCrashReportStatus:false];
        [Apptics setPersonalInfoTrackingStatus:true];
    }else if ([status isEqual: @(3)]){
        [Apptics setTrackingStatus:false];
        [Apptics setCrashReportStatus:true];
        [Apptics setPersonalInfoTrackingStatus:true];
        
    }else if ([status isEqual: @(4)]){
        [Apptics setTrackingStatus:true];
        [Apptics setCrashReportStatus:true];
        [Apptics setPersonalInfoTrackingStatus:false];
    }else if ([status isEqual: @(5)]){
        [Apptics setTrackingStatus:true];
        [Apptics setCrashReportStatus:false];
        [Apptics setPersonalInfoTrackingStatus:false];
    }else if ([status isEqual: @(6)]){
        [Apptics setTrackingStatus:false];
        [Apptics setCrashReportStatus:true];
        [Apptics setPersonalInfoTrackingStatus:false];
    }else{
        
    }
                 
    result(nil);
}

//trackingStatus
- (void)trackingStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    result(@([Apptics trackingStatus]));
}
//setTrackingStatus
- (void)setTrackingStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics setTrackingStatus:status.boolValue];
    result(nil);
}
//crashReportStatus
- (void)crashReportStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    result(@([Apptics crashReportStatus]));
}
//setCrashReportStatus
- (void)setCrashReportStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics setCrashReportStatus:status.boolValue];
    result(nil);
}
//personalInfoTrackingStatus
- (void)personalInfoTrackingStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    result(@([Apptics personalInfoTrackingStatus]));
}
//setPersonalInfoTrackingStatus
- (void)setPersonalInfoTrackingStatus:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics setPersonalInfoTrackingStatus:status.boolValue];
    result(nil);
}
//isUserLoggedIn
- (void)isUserLoggedIn:(FlutterMethodCall*)call result:(FlutterResult)result{
    result(@([Apptics isUserLoggedIn]));
}
//setSendAnalyticsDataUsingMobileData
- (void)setSendAnalyticsDataUsingMobileData:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics setSendAnalyticsDataUsingMobileData:status.boolValue];
    result(nil);
}
//sendAnalyticsDataUsingMobileData
- (void)sendAnalyticsDataUsingMobileData:(FlutterMethodCall*)call result:(FlutterResult)result{
    result(@([Apptics sendAnalyticsDataUsingMobileData]));
}
//getLocalizableStringForKey
- (void)getLocalizableStringForKey:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *key = call.arguments[@"key"];
    result([Apptics getLocalizableStringForKey:key]);
}
//setDefaultLanguage
- (void)setDefaultLanguage:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *lang = call.arguments[@"lang"];
    [Apptics setDefaultLanguage:lang];
    result(nil);
}
//setCurrentLocation
- (void)setCurrentLocation:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *location = call.arguments[@"location"];
    [Apptics setCurrentLocation:location];
    result(nil);
}
//setPrivacyConsentType
- (void)setPrivacyConsentType:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *type = call.arguments[@"type"];
    [Apptics setPrivacyConsentType:type.intValue];
    result(nil);
}
//setTypeOfAnonymity
- (void)setTypeOfAnonymity:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *type = call.arguments[@"type"];
    [Apptics setTypeOfAnonymity:type.intValue];
    result(nil);
}
//enableAutoCheckForAppUpdate
- (void)enableAutoCheckForAppUpdate:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSNumber *status = call.arguments[@"status"];
    [Apptics enableAutoCheckForAppUpdate:status.boolValue];
    result(nil);
}
//crash
- (void)crash:(FlutterMethodCall*)call result:(FlutterResult)result{
    [Apptics crash];
    result(nil);
}
//isReachable
- (void)isReachable:(FlutterMethodCall*)call result:(FlutterResult)result{
    result(@([Apptics isReachable]));
}
//addEvent:(NSString *)eventName andGroupName : (NSString*) groupName withProperties:(NSDictionary *)properties
- (void)addEvent:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *event = call.arguments[@"event"];
    NSString *group = call.arguments[@"group"];
    NSDictionary *custom_properties = call.arguments[@"properties"];
    [APEvent trackEvent:event andGroupName:group withProperties:custom_properties];
    result(nil);
}
//trackViewEnter
- (void)trackViewEnter:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *screen_name = call.arguments[@"screen_name"];
    [APScreentracker trackViewEnter:screen_name];
    result(nil);
}
//trackViewExit
- (void)trackViewExit:(FlutterMethodCall*)call result:(FlutterResult)result{
    NSString *screen_name = call.arguments[@"screen_name"];
    [APScreentracker trackViewExit:screen_name];
}

- (void)navigationController:(UINavigationController *)navigationController willShowViewController:(UIViewController *)viewController animated:(BOOL)animated{
    if (childviewcontrollers > 1){
        double delayInSeconds = 0.5;
        dispatch_time_t popTime = dispatch_time(DISPATCH_TIME_NOW, (int64_t)(delayInSeconds * NSEC_PER_SEC));
        dispatch_after(popTime, dispatch_get_main_queue(), ^(void){
            [window setHidden:true];
        });
    }
    childviewcontrollers = navigationController.childViewControllers.count;
}
@end
